    PROGRAM nag_mat_norm_ex07

      ! Example Program Text for nag_mat_norm
      ! NAG fl90, Release 4. NAG Copyright 2000.

      ! .. Use Statements ..
      USE nag_examples_io, ONLY : nag_std_in, nag_std_out
      USE nag_mat_norm, ONLY : nag_trap_mat_norm
      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Intrinsic Functions ..
      INTRINSIC KIND
      ! .. Parameters ..
      INTEGER, PARAMETER :: wp = KIND(1.0D0)
      ! .. Local Scalars ..
      INTEGER :: i, m, n
      CHARACTER (1) :: uplo
      ! .. Local Arrays ..
      COMPLEX (wp), ALLOCATABLE :: a(:,:)
      ! .. Executable Statements ..
      WRITE (nag_std_out,*) 'Example Program Results for nag_mat_norm_ex07'

      READ (nag_std_in,*)          ! Skip heading in data file
      READ (nag_std_in,*) m, n

      ALLOCATE (a(m,n))            ! Allocate storage

      READ (nag_std_in,*) (a(i,:),i=1,m)

      uplo = 'L'
      WRITE (nag_std_out,*)
      WRITE (nag_std_out,*) 'Norms of the lower trapezium of A'
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'One-norm of (A) =', &
       nag_trap_mat_norm(uplo,a)
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'Infinity Norm of (A) =', &
       nag_trap_mat_norm(uplo,a,norm='i')
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'Frobenius Norm of (A) =', &
       nag_trap_mat_norm(uplo,a,norm='f')
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'MAX(ABS(A(i,j))) =', &
       nag_trap_mat_norm(uplo,a,norm='m')

      uplo = 'u'
      WRITE (nag_std_out,*)
      WRITE (nag_std_out,*) &
       'Norms of the upper trapezium of A  - assuming unit diagonals'
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'One-norm of (A) =', &
       nag_trap_mat_norm(uplo,a,unit_diag=.TRUE.)
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'Infinity Norm of (A) =', &
       nag_trap_mat_norm(uplo,a,norm='i',unit_diag=.TRUE.)
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'Frobenius Norm of (A) =', &
       nag_trap_mat_norm(uplo,a,norm='f',unit_diag=.TRUE.)
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'MAX(ABS(A(i,j))) =', &
       nag_trap_mat_norm(uplo,a,norm='m',unit_diag=.TRUE.)

      DEALLOCATE (a)               ! Deallocate storage

    END PROGRAM nag_mat_norm_ex07
